import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'aliyun_oss_platform_interface.dart';
import 'src/method_channel_aliyun_oss.dart';

export 'src/method_channel_aliyun_oss.dart';
export 'constants.dart';
export 'src/model/export_model.dart';

class AliyunOSSPlatform extends PlatformInterface {
  AliyunOSSPlatform() : super(token: _token);

  static final Object _token = Object();
  OSSStsTokenCredentialProvider? provider;

  static AliyunOSSPlatform _instance = MethodChannelAliyunOSS();
  static AliyunOSSPlatform get instance => _instance;

  static set instance(AliyunOSSPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<String?> saveFileToDownload(String fileName, String mimeType) {
    throw UnimplementedError("openFolder() has not been implemented.");
  }

  getMd5Str(String filePath) {
    throw UnimplementedError("getMd5Str() has not been implemented.");
  }

  init(String endpoint, OSSCredentialProvider provider) {
    throw UnimplementedError('init() has not been implemented.');
  }

  upload(String bucketName) {
    throw UnimplementedError('putObject() has not been implemented.');
  }

  uploadWithPath(String bucketName, String filePath, String md5, String uuid) {
    throw UnimplementedError('uploadWithPath() has not been implemented.');
  }

  Future<String?> pauseUpload(String objectKey, String uuid) {
    throw UnimplementedError('pauseUpload() has not been implemented.');
  }

  Future<String?> resumeUpload(String objectKey, String uuid) {
    throw UnimplementedError('resumeUpload() has not been implemented.');
  }

  Future<String?> cancelUpload(String objectKey, String uuid) {
    throw UnimplementedError('cancelUpload() has not been implemented.');
  }

  Future<String?> cancelAllUpload() {
    throw UnimplementedError('cancelAllUpload() has not been implemented.');
  }

  download(String? bucketName, String md5, String fileName, String mimeType) {
    throw UnimplementedError('download() has not been implemented.');
  }

  Future<String?> pauseDownload(String objectKey) {
    throw UnimplementedError('pauseDownload() has not been implemented.');
  }

  Future<String?> resumeDownload(String objectKey) {
    throw UnimplementedError('resumeDownload() has not been implemented.');
  }

  void addUploadMethodCallListener(UploadMethodCallListener listener) {
    throw UnimplementedError(
        'addUploadMethodCallListener() has not been implemented.');
  }

  void removeUploadMethodCallListener(UploadMethodCallListener listener) {
    throw UnimplementedError(
        'removeUploadMethodCallListener() has not been implemented.');
  }

  void addDownloadMethodCallListener(DownloadMethodCallListener listener) {
    throw UnimplementedError(
        'addDownloadMethodCallListener() has not been implemented.');
  }

  void removeDownloadMethodCallListener(DownloadMethodCallListener listener) {
    throw UnimplementedError(
        'removeDownloadMethodCallListener() has not been implemented.');
  }
}
