import 'package:dart_numerics/dart_numerics.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

import 'oss_credential_provider.dart';
import 'oss_federation_token.dart';

part 'oss_sts_token_credential_provider.g.dart';

@JsonSerializable()
class OSSStsTokenCredentialProvider implements OSSCredentialProvider {
  OSSStsTokenCredentialProvider({
    required this.accessKeyId,
    required this.secretKeyId,
    required this.securityToken,
  });

  final String accessKeyId;
  final String secretKeyId;
  final String securityToken;

  factory OSSStsTokenCredentialProvider.fromJson(Map<String, dynamic> json) =>
      _$OSSStsTokenCredentialProviderFromJson(json);
  @override
  Map<String, dynamic> toJson() => _$OSSStsTokenCredentialProviderToJson(this);

  @override
  OSSFederationToken? getFederationToken() => OSSFederationToken(
      accessKeyId, secretKeyId, securityToken, int64MaxValue);
}
